Subject: Re: bug#78489: 30.1.50; Using etags, Ada and xref-find-definitions doesn't find definitions

From: Eli Zaretskii <[email-masked]>
Date: Mon, 14 Jul 2025 16:13:00 +0300

> From: Troy Brown <[email-masked]>
> Date: Mon, 14 Jul 2025 07:52:50 -0400
> Cc: [email-masked], [email-masked]
> 
> On Fri, Jul 11, 2025 at 2:49 AM Eli Zaretskii <[email-masked]> wrote:
> >
> > > > Ping!  Any further comments, or should I close this bug?
> > >
> > > I'd be fine if someone wanted to make it more general.  There are
> > > actually multiple Ada major modes available.  The ada-mode in ELPA is
> > > currently unmaintained, but there are at least 3 alternatives that I'm
> > > aware of (including my own ada-ts-mode).  The ideal solution is likely
> > > one where everyone can benefit, but barring someone wanting to drive
> > > this to a generalized conclusion, I'm fine with a mode-specific
> > > solution.
> >
> > To have this in the Ada modes out there, we need to bring the
> > respective authors on board of this discussion.  Would someone like to
> > do that, please?
> 
> Shouldn't this be an opt-in situation?  I suspect most alternative Ada
> modes won't care about this.

Sorry, I don't understand what you are saying.  Whether this should be
opt-in or not is generally up to the respective mode maintainers.

> How do you propose an unmaintained ada-mode is addressed?

Either modify it in its repository or post a patch to the relevant
forum?

Anyway making this change in the modes was not my proposal, so I
cannot be responsible for resolving all the potential issues that this
proposal raises.

> The following are the major modes I'm aware of that support Ada:
> - ada-mode (https://savannah.nongnu.org/projects/ada-mode/)
>   - Available on ELPA and currently unmaintained.
> - ada-ts-mode (https://github.com/brownts/ada-ts-mode)
>   - Available on MELPA and Github, I am the author/maintainer.
>   - I will be making the necessary changes to support etags.
> - old-ada-mode (https://github.com/tkurtbond/old-ada-mode)
>   - Available on Github.
>   - This is the version of ada-mode which shipped with Emacs (until Emacs 27).
>   - Some people prefer old-ada-mode over ada-mode due to the
> complexity of installation of ELPA ada-mode.
>   - It appears to be feature-locked and only incorporates bug fixes.
> - ada-light-mode (https://github.com/sebastianpoeplau/ada-light-mode)
>   - Available on Github.
>   - Relies on Ada LSP for much of its capability, therefore I suspect
> it's not interested in supporting etags.

I hope someone will reach out to the respective developers and add
them to this discussion, so we could finalize the solutions.